﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Service.BoardService;
using System.Collections.ObjectModel;
using Service;

namespace AnzeigenApp
{
    /// <summary>
    /// Interaktionslogik für AnzeigeView.xaml
    /// </summary>
    public partial class AnzeigeView : UserControl
    {
        public AnzeigeView()
        {
            InitializeComponent();
            images = new ObservableCollection<ImageSource>();
        }

        private static int x = 0;

        private ObservableCollection<ImageSource> images;

        public ObservableCollection<ImageSource> Images
        {
            get
            {
                return images;
            }
            set
            {
                if (images != value)
                {
                    images = value;
                    //this.OnPropertyChanged("Images");
                }
            }
        }

        private void UserControl_DataContextChanged(object sender, DependencyPropertyChangedEventArgs e)
        {
            Anzeige anzeige = e.NewValue as Anzeige;
            if (anzeige != null)
            {
                try
                {
                    textBlock1.Text = anzeige.Titel;
                    textBlock2.Text = anzeige.Text;
                    if (anzeige.Images.Count() > 0)
                        imgPreview.Source = BitmapLoader.GetImageSource(anzeige.Images.FirstOrDefault());
                    else
                        imgPreview.Height = 0;
                    //foreach (String path in anzeige.Images)
                    //    images.Add(BitmapLoader.GetImageSource(path));

                    //Image img1 = new Image();
                    //Image img2 = new Image();
                    //Image img3 = new Image();
                    //img1.Source = src1;
                    //img2.Source = src1;
                    //img3.Source = src1;

                    //pics.ItemsSource = Images;
                    //image1.Source = src;
                }
                catch (Exception ex)
                {
                    Visibility = Visibility.Hidden;
                }
            }
        }
    }
}
