﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ProfilKomponente;
using RechteVerwaltungsKomponente;

namespace AnzeigenKomponente
{
    public interface IAnzeigenKomponente
    {
        TransportAnzeige AnzeigeErstellen(int accountID, string titel, string beschreibung, string text, IList<Tag> tags,
            IDictionary<int, int> kategorie, string appearance, IList<int> images, KontaktOptionen kontaktOptionen);
        TransportAnzeige AnzeigeAktualisieren(int accountID, int anzeigeID, string titel, string beschreibung, string text, IList<Tag> tags,
            IDictionary<int, int> kategorie, string appearance, IList<int> images);
        bool AnzeigeSetÖffentlichStatus(int accountID, int anzeigeID, bool status, AccountType type);
        bool AnzeigeLöschen(int accountID, int anzeigeID, AccountType type);
        bool IstOwnAnzeige(int accountID, int anzeigeID);
        IList<TransportAnzeige> GetAllAnzeigen(AccountType type, int chunk);
        IList<TransportAnzeige> GetALLOwnAnzeigen(int accountID, int chunk);
        TransportAnzeige GetAnzeige(int accountID, int anzeigeID, AccountType type);
        IList<TransportAnzeige> GetAllAnzeigenFromUser(int ownAccountID, int userAccountID, AccountType type, int chunk);
        IList<Kategorie> GetAllKategorien();
        IList<Tag> GetAllTags();
        bool SendeAnzeigePerMail(int accountID, string empfänger, int anzeigeID, AccountType type);
        Kategorie ErstelleKategorie(string name, IList<string> unterkategorien);
        bool LöscheKategorie(int id);
    }
}
