﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using FluentNHibernate.Mapping;

namespace BilderKomponente
{
    public class Image
    {
        public virtual int ID { get; set; }
        public virtual int AccountID { get; set; }
        public virtual string Hash { get; private set; }
        public virtual string Pfad { get; private set; }
        public virtual string VirtuellerPfad { get; private set; }

        public Image() { }

        public Image(string pfad, int accountID, string hash, string virtuellerPfad)
        {
            this.Pfad = pfad;
            this.AccountID = accountID;
            this.Hash = hash;
            this.VirtuellerPfad = virtuellerPfad;
        }
    }

    public class ImageMap : ClassMap<Image>
    {
        public ImageMap()
        {
            Id(x => x.ID);
            Map(x => x.AccountID);
            Map(x => x.Hash).Unique();
            Map(x => x.Pfad).Unique();
            Map(x => x.VirtuellerPfad).Unique();
        }
    }
}
