﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Service;

namespace CampusBoardWebsite
{
    public partial class Aktivieren : AuthorizedContentWebPage
    {
        private string guid, code;

        protected void Page_Load(object sender, EventArgs e)
        {
            CheckSession();
            if (isLoggedIn())
            {
                if (isActive())
                {
                    Response.Redirect("Erstellen.aspx");
                    return;
                }
                else
                {
                    if (hasParameters())
                    {
                        if (activationSuccess())
                        {
                            alertSuccess.Visible = true;
                            lblSuccess.Text = "Die Aktivierung war erfolgreich, klicke auf Erstellen und leg los!!";
                        }
                        else
                        {
                            alertError.Visible = true;
                            lblError.Text = "Aktivierung nicht erfolgreich. Versuch es erneut indem du die Aktivierungsmail erneut anforderst, oder kontaktiere den Support an campus-board@marius-klausa.eu";
                            divButton.Visible = true;
                        }
                    }
                    else
                    {
                        alertError.Visible = true;
                        lblError.Text = "Aktivierung nicht erfolgreich. Überprüf dein Postfach oder fordere die Aktivierungsmail erneut an";
                        divButton.Visible = true;
                    }
                }
            }
            else
            {
                if (hasParameters())
                {
                    if (activationSuccess())
                    {
                        alertSuccess.Visible = true;
                        lblSuccess.Text = "Die Aktivierung war erfolgreich, du kannst dich nun einloggen und loslegen!!";
                    }
                    else
                    {
                        alertError.Visible = true;
                        lblError.Text = "Aktivierung nicht erfolgreich. Bitte logge dich ein und fordere die Aktivierungsmail erneut an";
                    }
                }
                else
                {
                    alertError.Visible = true;
                    lblError.Text = "Aktivierung nicht erfolgreich. Bitte logge dich ein und fordere die Aktivierungsmail erneut an";
                }
            }
        }

        private bool isLoggedIn()
        {
            return (!String.IsNullOrEmpty(Guid));
        }

        private bool isActive()
        {
            return (this.LoginState == LoginState.active);
        }

        private bool hasParameters()
        {
            guid = Request.QueryString["guid"];
            code = Request.QueryString["code"];
            return (!String.IsNullOrEmpty(guid) && !String.IsNullOrEmpty(code));
        }

        private bool activationSuccess()
        {
            var fassade = new Proxy();
            if (fassade.AccountAktivieren(guid, code))
            {
                if (isLoggedIn())
                    Session.Add("state", LoginState.active);
                return true;
            }
            return false;
        }

        protected void btnSendmail_Click(object sender, EventArgs e)
        {
            var fassade = new Proxy();
            if (fassade.SendeAktivierungsmail(Guid))
            {
                alertError.Visible = false;
                alertInfo.Visible = false;
                lblSuccess.Text = "Aktivierungsmail wurde verschickt";
                alertSuccess.Visible = true;
            }
            else
            {
                lblError.Text = "Irgendetwas ist schief gegangen. Kontaktiere den Support unter campus-board@marius-klausa.eu";
                alertError.Visible = true;
                alertInfo.Visible = false;
                alertSuccess.Visible = false;
            }
        }
    }
}