﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace CampusBoardWebsite
{
    public class AuthorizedContentWebPage : System.Web.UI.Page
    {
        protected String Guid;
        protected LoginState LoginState;

        public void CheckSessionAndRedirect(bool needsActiveState)
        {
            if (Session["state"] == null)
                this.LoginState = LoginState.loggedOff;
            else
                this.LoginState = (LoginState)Session["state"];
            if (this.LoginState != LoginState.loggedOff)
            {
                if (!String.IsNullOrEmpty((string)Session["guid"]))
                {
                    Guid = (string)Session["guid"];
                }
                else
                    this.LoginState = LoginState.loggedOff;
            }

            if (this.LoginState == LoginState.loggedOff || (needsActiveState && this.LoginState == LoginState.inactive))
                Response.Redirect("Default.aspx");
        }

        protected void CheckSession()
        {
            if (Session["state"] == null)
                this.LoginState = LoginState.loggedOff;
            else
                this.LoginState = (LoginState)Session["state"];
            if (this.LoginState != LoginState.loggedOff)
            {
                if (!String.IsNullOrEmpty((string)Session["guid"]))
                {
                    Guid = (string)Session["guid"];
                }
                else
                    this.LoginState = LoginState.loggedOff;
            }
        }
    }
}