﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Configuration;

namespace Common
{
    public class AppConfHelper
    {
        /// <summary>
        /// Ruft den Wert in der Konfigurationsdatei
        /// der aktuellen Anwendung ab und gibt diesen als string zurück
        /// </summary>
        /// <param name="key">Der Name des Wertes</param>
        /// <returns></returns>
        public static string GetValueAsString(String key)
        {
            return ConfigurationManager.AppSettings[key];
        }

        /// <summary>
        /// Ruft den Wert in der Konfigurationsdatei
        /// der aktuellen Anwendung ab und gibt diesen als int zurück
        /// </summary>
        /// <param name="key">Der Name des Wertes</param>
        /// <returns></returns>
        public static int GetValueAsInt(String key)
        {
            int val;
            int.TryParse(ConfigurationManager.AppSettings[key], out val);
            return val;
        }

        /// <summary>
        /// Ruft den Wert in der Konfigurationsdatei
        /// der aktuellen Anwendung ab und gibt diesen als bool zurück
        /// </summary>
        /// <param name="key">Der Name des Wertes</param>
        /// <returns></returns>
        public static bool GetValueAsBool(String key)
        {
            bool val;
            bool.TryParse(ConfigurationManager.AppSettings[key], out val);
            return val;
        }
    }
}
