﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.IO;

namespace AnzeigenApp
{
    public class BitmapLoader
    {
        private static IDictionary<String, String> images = new Dictionary<String, String>();

        public static ImageSource GetImageSource(String path)
        {
            if (String.IsNullOrEmpty(path))
                return null;
            BitmapImage image = null;
            lock (images)
            {
                if (images.ContainsKey(path))
                {
                    try
                    {
                        String savePath;
                        if (images.TryGetValue(path, out savePath))
                            image = new BitmapImage(new Uri(savePath));
                    }
                    catch (Exception ex) { }
                }
                if (image == null)
                {
                    image = new BitmapImage(new Uri(path));
                    image.DownloadCompleted += objImage_DownloadCompleted;


                    //while (result.IsDownloading) ;

                    //BitmapEncoder encoder = new JpegBitmapEncoder();
                    //encoder.Frames.Add(BitmapFrame.Create(result));
                    //var fileStream = new FileStream("E:\\pic1.png", FileMode.Create);
                    //encoder.Save(fileStream);
                }
                return image;
            }
        }

        private static void objImage_DownloadCompleted(object sender, EventArgs e)
        {
            try
            {
                BitmapImage source = sender as BitmapImage;
                if (images.ContainsKey(source.UriSource.ToString()))
                    return;
                JpegBitmapEncoder encoder = new JpegBitmapEncoder();
                encoder.Frames.Add(BitmapFrame.Create((BitmapImage)sender));
                Guid photoID = System.Guid.NewGuid();
                String photolocation = "C://pics//" + photoID.ToString() + ".jpg";  //file name 

                images.Add(new KeyValuePair<string, string>(source.UriSource.ToString(), photolocation));


                using (var filestream = new FileStream(photolocation, FileMode.Create))
                    encoder.Save(filestream);
            }
            catch (Exception ex) { }
        }
    }
}
