﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using BasisKlassen;
using Common.Logger;
using Service;

namespace InfoApp
{
    /// <summary>
    /// Interaktionslogik für FeedbackView.xaml
    /// </summary>
    public partial class FeedbackView : MyUserControl
    {
        private Model model;

        public FeedbackView(Model model)
        {
            InitializeComponent();
            DataContext = this;
            this.model = model;
            Title = "FEEDBACK GEBEN";
        }

        private void surfaceButton1_Click(object sender, RoutedEventArgs e)
        {
            bool result = false;
            try
            {
                Logger.LogEvent(LogEvent.FeedbackAbgeschickt, model.Guid);
                var proxy = new Proxy();
                result = proxy.PostFeedback(model.Guid, feedbackText.Text);
            }
            catch (Exception ex)
            {
            }
            if (result)
                resultText.Text = "Danke für deine Meinung\r\nSie wird mit Sicherheit berücksichtigt";
            else
                resultText.Text = "Irgendetwas ist schiefgegangen\r\nDeine Nachricht konnte leider nicht gesendet werden";
            secondView.Visibility = Visibility.Visible;
            firstView.Visibility = Visibility.Hidden;
        }

        private void MyUserControl_Loaded_1(object sender, RoutedEventArgs e)
        {
            Logger.LogEvent(LogEvent.FeedbackAufgerufen, model.Guid);
            feedbackText.Text = String.Empty;
            firstView.Visibility = Visibility.Visible;
            secondView.Visibility = Visibility.Hidden;
        }
    }
}
