﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Service.BoardService;
using System.Windows.Forms;
using System.Windows.Threading;
using LoginRegisterApp;
using System.Threading.Tasks;
using com.google.zxing.common;
using System.Threading;
using com.google.zxing;
using System.Drawing;
using System.IO;
using System.Drawing.Imaging;
using System.Runtime.InteropServices;
using BasisKlassen;
using System.Diagnostics;

namespace LoginRegisterApp
{
    /// <summary>
    /// Interaktionslogik für LoginRegisterMainView.xaml
    /// </summary>
    public partial class LoginView : MyUserControl
    {
        private Model model;

        PictureBox camBox;
        Capture cam;
        Dispatcher dispatcher;
        const int VIDEODEVICE = 0; // zero based index of video capture device to use
        const int VIDEOWIDTH = 640; // Depends on video device caps
        const int VIDEOHEIGHT = 480; // Depends on video device caps
        const int VIDEOBITSPERPIXEL = 24; // BitsPerPixel values determined by device
        private bool isRunning = false;
        private Thread Runner;

        private bool isActive = true;

        public bool IsActive
        {
            get { return isActive; }
            set
            {
                if (isActive != value)
                    isActive = value;
            }
        }

        public LoginView(Model model)
        {
            InitializeComponent();
            this.model = model;
            DataContext = this;
            Title = "LOGIN";
            dispatcher = Dispatcher.CurrentDispatcher;
            try
            {
                camBox = new PictureBox();
                cam = new Capture(VIDEODEVICE, VIDEOWIDTH, VIDEOHEIGHT, VIDEOBITSPERPIXEL, camBox);
                Runner = new Thread(new ThreadStart(takeCamPicture));
                Runner.Start();
            }
            catch (Exception ex) { }
        }

        //private string title;
        //public string Title
        //{
        //    get { return title; }
        //    set
        //    {
        //        if (Title != value)
        //        {
        //            title = value;
        //            //this.OnPropertyChanged("Title");
        //        }
        //    }
        //}

        private void surfaceButton1_Click(object sender, RoutedEventArgs e)
        {
            String guid = null;
            IFassadeSOAPInterface fassade = new FassadeSOAPInterfaceClient();
            try
            {
                string mail = surfaceTextBox1.Text.ToLower().Replace("@haw-hamburg.de", "");
                if (!mail.Contains('@'))
                    mail += "@haw-hamburg.de";
                guid = fassade.Login(mail, surfacePasswordBox1.Password);
            }
            catch (Exception ex) { }
            if (String.IsNullOrEmpty(guid))
                resultText.Text = "Falsche Login Daten";
            else
            {
                Common.Logger.Logger.LogEvent(Common.Logger.LogEvent.LoginAusgeführt, model.Guid);
                if (fassade.IstAccountAktiviert(guid))
                {
                    model.Guid = guid;
                    resultText.Text = "Du wurdest erfolgreich eingeloggt!";
                }
                else
                    resultText.Text = "Dein Account ist noch nicht aktiviert. Schaue in deinem Postfach nach, oder log dich auf der Website ein und" +
                        " fordere die Aktivierungsmail erneut an.";
            }
            firstView.Visibility = Visibility.Hidden;
            secondView.Visibility = Visibility.Visible;
            surfaceTextBox1.Clear();
            surfacePasswordBox1.Clear();
        }


        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            //try
            //{

            //    Runner = new Thread(new ThreadStart(takeCamPicture));
            firstView.Visibility = Visibility.Visible;
            secondView.Visibility = Visibility.Hidden;
            Common.Logger.Logger.LogEvent(Common.Logger.LogEvent.LoginAufgerufen, model.Guid);
            isRunning = true;
            //Process.Start("osk.exe");
            //    Runner.Start();
            //}
            //catch (Exception ex) { }
        }

        IntPtr m_ip = IntPtr.Zero;
        void takeCamPicture()
        {
            DateTime oldTime = DateTime.Now;
            int fpsCounter = 0;
            DateTime recognizedTime = DateTime.Now;
            while (isActive)
            {
                try
                {
                    if (isRunning)
                    {
                        if (m_ip != IntPtr.Zero)
                        {
                            Marshal.FreeCoTaskMem(m_ip);
                            m_ip = IntPtr.Zero;
                        }
                        m_ip = cam.Click();
                        Bitmap b = new Bitmap(cam.Width, cam.Height, cam.Stride, System.Drawing.Imaging.PixelFormat.Format24bppRgb, m_ip);
                        b.RotateFlip(RotateFlipType.RotateNoneFlipY);
                        fpsCounter++;
                        this.Dispatcher.Invoke(DispatcherPriority.Background, (Action)(() =>
                        {
                            using (MemoryStream stream = new MemoryStream())
                            {
                                b.Save(stream, ImageFormat.Png);
                                stream.Position = 0;
                                BitmapImage bitmap = new BitmapImage();
                                bitmap.BeginInit();
                                bitmap.StreamSource = stream;
                                bitmap.CacheOption = BitmapCacheOption.OnLoad;
                                bitmap.EndInit();
                                camPreview.Source = bitmap;
                            }
                        }));
                        if ((DateTime.Now - oldTime) >= new TimeSpan(0, 0, 0, 0, 500))
                        {
                            //Main.FPS = (fpsCounter * 2).ToString();
                            //fpsCounter = 0;
                            oldTime = DateTime.Now;
                            Bitmap b2 = (Bitmap)b.Clone();
                            if ((DateTime.Now - recognizedTime) >= new TimeSpan(0, 0, 0, 5))
                                new Thread(new ThreadStart(() =>
                                {
                                    try
                                    {

                                        if (String.IsNullOrEmpty(model.Guid))
                                        {
                                            Reader reader = new MultiFormatReader();
                                            Binarizer b1 = new HybridBinarizer(new RGBLuminanceSource(b2, b2.Width, b2.Height));

                                            Result res = reader.decode(new BinaryBitmap(b1));
                                            String accMail = null;
                                            try
                                            {
                                                IFassadeSOAPInterface fassade = new FassadeSOAPInterfaceClient();
                                                accMail = fassade.GetAccountMail(res.Text);
                                            }
                                            catch (Exception ex) { }
                                            if (String.IsNullOrEmpty(model.Guid))
                                            {
                                                if (!String.IsNullOrEmpty(accMail))
                                                {
                                                    this.Dispatcher.Invoke(DispatcherPriority.Background, (Action)(() =>
                                                    {
                                                        Common.Logger.Logger.LogEvent(Common.Logger.LogEvent.QRCodeLoginAusgeführt, model.Guid);
                                                        model.Guid = res.Text;
                                                    }));
                                                }
                                                recognizedTime = DateTime.Now;
                                            }
                                        }
                                    }
                                    catch (Exception ex)
                                    {
                                    }
                                })).Start();
                        }
                    }
                }
                catch (Exception ex)
                {
                    Common.Logger.Logger.LogEvent(Common.Logger.LogEvent.None, "Fehler bei Kamera:" + ex.Message);
                }
            }
            cam.Dispose();
        }

        private void UserControl_Unloaded(object sender, RoutedEventArgs e)
        {
            isRunning = false;
            //Runner.Interrupt();
            //isRunning
        }

        private void SurfaceButton_Click_1(object sender, RoutedEventArgs e)
        {
            firstView.Visibility = Visibility.Visible;
            secondView.Visibility = Visibility.Hidden;
        }
    }
}
