﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using BasisKlassen;
using Common.Logger;
using Service.BoardService;

namespace LoginRegisterApp
{
    /// <summary>
    /// Interaktionslogik für RegisterView.xaml
    /// </summary>
    public partial class RegisterView : MyUserControl
    {
        private Model model;

        public RegisterView(Model model)
        {
            InitializeComponent();
            this.model = model;
            InitializeComponent();
            DataContext = this;
            Title = "REGISTRIEREN";
        }

        private void surfaceButton1_Click(object sender, RoutedEventArgs e)
        {
            string email = surfaceTextBox1.Text.ToLower().Replace("@haw-hamburg.de", "") + "@haw-hamburg.de";
            if (!chkAgb.IsChecked.Value)
            {
                resultText.Text = "Du musst mit den Nutzungsbedingungen einverstanden sein.";
                firstView.Visibility = Visibility.Hidden;
                secondView.Visibility = Visibility.Visible;
                agbView.Visibility = Visibility.Hidden;
                return;
            }
            String guid = null;
            if (String.IsNullOrEmpty(surfacePasswordBox1.Password))
                resultText.Text = "Email und oder Passwort dürfen nicht leer sein";
            else if (!surfacePasswordBox1.Password.Equals(surfacePasswordBox2.Password))
                resultText.Text = "Die Passwörster stimmen nicht überein";
            else if (checkEmail(email))
            {
                try
                {
                    IFassadeSOAPInterface fassade = new FassadeSOAPInterfaceClient();
                    guid = fassade.Registrieren(email, surfacePasswordBox1.Password);
                }
                catch (Exception ex) { }
                if (String.IsNullOrEmpty(guid))
                {
                    resultText.Text = "Beim Registrieren ist irgendetwas schiefgegangen";
                }
                else
                {
                    Logger.LogEvent(LogEvent.RegistrierenAusgeführt, model.Guid);
                    resultText.Text = "Du hast dich erfolgreich registriert, bitte schaue in deinem Postfach nach und bestätige deinen Account";
                }
            }
            firstView.Visibility = Visibility.Hidden;
            secondView.Visibility = Visibility.Visible;
            agbView.Visibility = Visibility.Hidden;
            surfaceTextBox1.Clear();
            surfacePasswordBox1.Clear();
            surfacePasswordBox2.Clear();
        }

        private bool checkEmail(string mail)
        {
            if (String.IsNullOrEmpty(mail))
            {
                resultText.Text = "Email und oder Passwort dürfen nicht leer sein";
                return false;
            }
            if (mail.Count(x => x.Equals('@')) != 1)
            {
                resultText.Text = "Ungültiges Email-Format";
                return false;
            }
            if (!mail.Substring(mail.IndexOf("@")).ToLower().Equals("@haw-hamburg.de"))
            {
                resultText.Text = "Du darfst dich nur mit einer @haw-hamburg.de Adresse registrieren";
                return false;
            }
            return true;
        }

        private void MyUserControl_Loaded_1(object sender, RoutedEventArgs e)
        {
            firstView.Visibility = Visibility.Visible;
            secondView.Visibility = Visibility.Hidden;
            agbView.Visibility = Visibility.Hidden;
            Logger.LogEvent(LogEvent.RegistrierenAufgerufen, model.Guid);
        }

        private void SurfaceButton_Click_1(object sender, RoutedEventArgs e)
        {
            firstView.Visibility = Visibility.Visible;
            secondView.Visibility = Visibility.Hidden;
            agbView.Visibility = Visibility.Hidden;
        }

        private void TextBlock_TouchDown(object sender, TouchEventArgs e)
        {
            firstView.Visibility = Visibility.Hidden;
            secondView.Visibility = Visibility.Hidden;
            agbView.Visibility = Visibility.Visible;
        }

        private void SurfaceButton_Click(object sender, RoutedEventArgs e)
        {
            firstView.Visibility = Visibility.Visible;
            secondView.Visibility = Visibility.Hidden;
            agbView.Visibility = Visibility.Hidden;
        }
    }
}
