﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Common;
using System.Net;
using System.Net.Mail;
using System.Threading.Tasks;
using System.Threading;
using RechteVerwaltungsKomponente;
using BilderKomponente;
using Net.Mail;
using System.IO;

namespace MailKomponente
{
    public class MailKomponente
    {

        private RechteVerwaltung rechteVerwaltung = null;
        private BilderKomponente.BilderKomponente bilderKomponente = null;
        //private DirectoryInfo imageDirectory;

        public MailKomponente(RechteVerwaltung rechteVerwaltung, BilderKomponente.BilderKomponente bilderKomponente)
        {
            this.rechteVerwaltung = rechteVerwaltung;
            this.bilderKomponente = bilderKomponente;
            //try
            //{
            //    this.imageDirectory = Directory.CreateDirectory("images");
            //}
            //catch (Exception e)
            //{
            //    Console.WriteLine("Fehler beim erzeugen des Image Verzeichnisses:" + e.Message);
            //    Console.WriteLine(e.StackTrace);
            //}
        }

        public void Start()
        {
            new Task(() => Run()).Start();
        }

        private void Run()
        {
            while (true)
            {
                //if (imageDirectory == null)
                //{
                //    Console.WriteLine("imageDirectory fehlt, MailKomponente wird beendet");
                //    break;
                //}
                Console.WriteLine("MailKomponente läuft");
                Thread.Sleep(new TimeSpan(0, 0, 10));
                //Emails abrufen. Für jede Mail rechteVerwaltung.GetAccountID("mail"); aufrufen.
                Pop3Client client;
                foreach (Pop3ListItem item in ReadMails(out client))
                {
                    try
                    {
                        MailMessageEx message = client.RetrMailMessageEx(item);
                        int accountID = rechteVerwaltung.GetAccountID(message.From.Address);
                        if (accountID == -1)
                        {
                            Console.WriteLine("Benutzer {0} existiert nicht.", message.From.Address);
                            continue;
                        }
                    }
                    catch (Exception e)
                    {
                        Console.WriteLine("Fehler beim Auslesen der Email:" + e.Message);
                    }
                }
            }
        }

        private List<Pop3ListItem> ReadMails(out Pop3Client client)
        {
            try
            {
                MailConfig mailConfig = new MailConfig();
                client = new Pop3Client(mailConfig.Pop3Server, mailConfig.Pop3Port, mailConfig.SSL, mailConfig.Username, mailConfig.Passwort);
                client.Authenticate();
                //Stat stat = client.Stat();
                return client.List();
            }
            catch (Exception e)
            {
                Console.WriteLine("Fehler Erstellen des Pop3 Clients:" + e.Message);
            }
            client = null;
            return new List<Pop3ListItem>();
        }

        private static bool SendMail(string absender, string empfänger, string betreff, string text, bool isHtml)
        {
            try
            {
                empfänger = empfänger.Replace("ä", "ae").Replace("ü", "ue").Replace("ö", "oe");
                MailConfig mailConfig = new MailConfig();
                Console.WriteLine("Sende mail an {0}\n{1}", empfänger, mailConfig);
                MailMessage message = new MailMessage(absender, empfänger, betreff, text);
                message.IsBodyHtml = isHtml;
                SmtpClient client = new SmtpClient(
                    mailConfig.SmtpServer,
                    mailConfig.SmtpPort);
                NetworkCredential cred = new NetworkCredential(
                    mailConfig.Username,
                    mailConfig.Passwort);
                client.Credentials = cred;
                client.EnableSsl = mailConfig.SSL;
                client.Send(message);
            }
            catch (Exception e)
            {
                Console.WriteLine("Senden fehlgeschlagen:{0}", e.Message);
                return false;
            }
            return true;
        }

        //public static bool SendMail(string absender, string empfänger, string betreff, string text)
        //{
        //    MailConfig mailConfig = new MailConfig();
        //    return SendMail(absender, empfänger, betreff, text, false);         
        //}

        public static bool SendMail(string empfänger, string betreff, string text)
        {
            MailConfig mailConfig = new MailConfig();
            return SendMail(mailConfig.DefaultAbsender, empfänger, betreff, text, false);
        }

        //public static bool SendHtmlMail(string absender, string empfänger, string betreff, string text)
        //{
        //    MailConfig mailConfig = new MailConfig();
        //    return SendMail(absender, empfänger, betreff, text, true);
        //}

        public static bool SendHtmlMail(string empfänger, string betreff, string text)
        {
            MailConfig mailConfig = new MailConfig();
            return SendMail(mailConfig.DefaultAbsender, empfänger, betreff, text, true);
        }

        class MailConfig
        {
            public string DefaultAbsender { get; private set; }
            public string SmtpServer { get; private set; }
            public string Pop3Server { get; private set; }
            public int Pop3Port { get; private set; }
            public int SmtpPort { get; private set; }
            public string Username { get; private set; }
            public string Passwort { get; private set; }
            public bool SSL { get; private set; }

            public MailConfig()
            {
                SmtpServer = AppConfHelper.GetValueAsString("smtpserver");
                Pop3Server = AppConfHelper.GetValueAsString("pop3server");
                Pop3Port = AppConfHelper.GetValueAsInt("pop3port");
                SmtpPort = AppConfHelper.GetValueAsInt("smtpport");
                DefaultAbsender = AppConfHelper.GetValueAsString("defaultabsender");
                Username = AppConfHelper.GetValueAsString("username");
                Passwort = AppConfHelper.GetValueAsString("passwort");
                SSL = AppConfHelper.GetValueAsBool("ssl");
            }

            public override string ToString()
            {
                return String.Format("Mailconfig\nUsername:{0}\nSmtpServer:{1}\nSSL:{2}", Username, SmtpServer, SSL);
            }
        }
    }
}
