﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NHibernate;

namespace PersistenzManager
{
    public interface IPersistenz
    {
        T Save<T>(T obj) where T : class;
        IList<T> GetAll<T>() where T : class;
        T GetById<T, I>(I id) where T : class;
        void Delete<T>(T obj) where T : class;
        IQueryable<T> LinqQuery<T>() where T : class;
    }

    public delegate void TransactionalCode();

    public interface IConversationFactory
    {
        IConversation NewConversation();
    }

    public interface IConversation : IDisposable
    {
        void ExecuteTransactional(TransactionalCode body);
        void Reset();
        void End();
    }
}
