﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using AnzeigenApp;
using BasisKlassen;
using Common.Logger;
using Service;
using Service.BoardService;

namespace ProfilApp
{
    /// <summary>
    /// Interaktionslogik für AlleProfileView.xaml
    /// </summary>
    public partial class AlleProfileView : MyUserControl
    {

        private Model model;
        public Model Model
        {
            get { return model; }
            set
            {
                if (Model != value)
                {
                    model = value;
                    this.OnPropertyChanged("Model");
                }
            }
        }

        public AlleProfileView(Model model)
        {
            InitializeComponent();
            DataContext = this;
            this.model = model;
            model.PropertyChanged += GuidChanged;
            Title = "PROFILE";
            profile = new ObservableCollection<ProfileHolder>();
        }

        private string guid;
        public string Guid
        {
            get { return guid; }
            set
            {
                if (Guid != value)
                {
                    guid = value;
                    this.OnPropertyChanged("Guid");
                }
            }
        }

        private void GuidChanged(object obj, System.ComponentModel.PropertyChangedEventArgs args)
        {
            if (!args.PropertyName.Equals("Guid"))
                return;
            var model = obj as ProfilApp.Model;
            if (model != null)
            {
                Guid = model.Guid;
            }
        }

        private ObservableCollection<ProfileHolder> profile;
        public ObservableCollection<ProfileHolder> Profile
        {
            get
            {
                return profile;
            }
            set
            {
                if (Profile != value)
                {
                    profile = value;
                    this.OnPropertyChanged("Profile");
                }
            }
        }

        private void UserControl_Loaded_1(object sender, RoutedEventArgs e)
        {
            try
            {
                Logger.LogEvent(LogEvent.ProfileAufgerufen, model.Guid);
                Proxy fassade = new Proxy();
                List<ProfilVorschau> profile = fassade.GetAlleProfile(model.Guid == null ? String.Empty : model.Guid).ToList();
                this.profile.Clear();
                profile = profile.OrderBy(x => x.Displayname).ToList();
                foreach (ProfilVorschau p in profile)
                    Profile.Add(new ProfileHolder() { Displayname = p.Displayname, Profilbild = p.Profilbild, Source = BitmapLoader.GetImageSource(p.Profilbild), RegisteredEmail = p.RegisteredEmail });
            }
            catch (Exception ex) { }
        }
    }
}
