﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using System.Windows.Controls;
using System.ComponentModel;
using Microsoft.Surface.Presentation.Controls;
using BasisKlassen;

namespace ProfilApp
{
    public class Model : BaseModel, INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;
        AlleProfileView alleProfileView;
        MeinProfilView meinProfilView;

        public Model(SurfaceWindow parent)
        {
            parent.Closing += SurfaceWindow_Closing;
            Views = new ObservableCollection<Control>();
            alleProfileView = new AlleProfileView(this);
            views.Add(alleProfileView);
            meinProfilView = new MeinProfilView(this);
            //views.Add(meinProfilView);
        }
        private ObservableCollection<Control> views;

        public ObservableCollection<Control> Views
        {
            get
            {
                return views;
            }
            set
            {
                if (Views != value)
                {
                    views = value;
                    //this.OnPropertyChanged("Views");
                }
            }
        }

        public String Guid
        {
            get { return guid; }
            set
            {
                if (guid != value)
                {
                    guid = value;
                    this.OnPropertyChanged("Guid");
                    if (String.IsNullOrEmpty(guid))
                    {
                        views.Remove(meinProfilView);
                    }
                    else
                    {
                        views.Add(meinProfilView);
                    }
                }
            }
        }

        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        private void SurfaceWindow_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            //loginView.IsActive = false;
        }
    }
}
