﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using FluentNHibernate.Mapping;
using Common;

namespace ProfilKomponente
{
    [DataContract(Namespace = "http://marius-klausa.eu/board")]
    public class Profil
    {
        public virtual int AccountID { get; private set; }
        public virtual int ID { get; private set; }
        [DataMember]
        public virtual String Nickname { get; set; }
        [DataMember]
        public virtual String RegisteredEmail { get; set; }
        [DataMember]
        public virtual String Profilbild { get; set; }
        [DataMember]
        public virtual int AnzeigenVeröffentlicht { get; set; }
        [DataMember]
        public virtual KontaktDetails KontaktDetails { get; set; }
        [DataMember]
        public virtual bool Sichtbar { get; set; }

        public Profil() { }

        public Profil(int accountID, String registeredEmail)
        {
            this.AccountID = accountID;
            this.RegisteredEmail = registeredEmail;
            Profilbild = AppConfHelper.GetValueAsString("avatar_placeholder");
            KontaktDetails = new KontaktDetails() { Email = registeredEmail };
            Sichtbar = false;
        }


        public virtual Profil GetVisibleProfile()
        {
            Profil clone = this.MemberwiseClone() as Profil;
            clone.KontaktDetails = KontaktDetails.GetVisibleKontaktDetails();
            return clone;
        }
    }

    public class ProfilMap : ClassMap<Profil>
    {
        public ProfilMap()
        {
            Id(x => x.ID);
            Map(x => x.RegisteredEmail).Unique();
            Map(x => x.AccountID).Unique();
            Map(x => x.Nickname);
            Map(x => x.Profilbild);
            Map(x => x.AnzeigenVeröffentlicht);
            Map(x => x.Sichtbar);
            References(x => x.KontaktDetails).LazyLoad(Laziness.False).Cascade.All();
        }
    }
}
