﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PersistenzManager;

namespace ProfilKomponente
{
    public class ProfilVerwalter
    {
        private IPersistenz persistenz;

        public ProfilVerwalter(IPersistenz persistenz)
        {
            this.persistenz = persistenz;
        }

        public void SaveProfil(Profil p)
        {
            persistenz.Save<Profil>(p);
        }

        public Profil GetProfil(int accountID)
        {
            return (from Profil p in persistenz.LinqQuery<Profil>()
                    where (p.AccountID.Equals(accountID))
                    select p).SingleOrDefault();
        }

        public Profil GetProfil(string registeredMail)
        {
            return (from Profil p in persistenz.LinqQuery<Profil>()
                    where (p.RegisteredEmail.Equals(registeredMail))
                    select p).SingleOrDefault();
        }

        public IList<Profil> GetAlleProfile(bool onlyVisible)
        {
            if (onlyVisible)
                return (from Profil p in persistenz.LinqQuery<Profil>()
                        where p.Sichtbar
                        select p).ToList();
            return (from Profil p in persistenz.LinqQuery<Profil>()
                    select p).ToList();
        }

        public string GetNickname(int accountID)
        {
            return persistenz.LinqQuery<Profil>().Where(x => x.AccountID.Equals(accountID)).Select(x => x.Nickname).SingleOrDefault();
        }
    }
}
