﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using FluentNHibernate.Mapping;

namespace RechteVerwaltungsKomponente
{
    public class Account
    {
        public virtual int ID { get; set; }
        public virtual string Guid { get; private set; }
        public virtual string Email { get; set; }
        public virtual string Passwort { get; set; }
        public virtual AccountType Status { get; set; }
        public virtual DateTime Created { get; set; }

        public Account() { }

        public Account(string email, string passwort, AccountType status, Guid guid)
        {
            this.Email = email;
            this.Passwort = passwort;
            this.Status = status;
            this.Guid = guid.ToString();
            Created = DateTime.Now;
        }
    }

    public class AccountMap : ClassMap<Account>
    {
        public AccountMap()
        {
            Id(x => x.ID);
            Map(x => x.Guid).Unique();
            Map(x => x.Email).Unique();
            Map(x => x.Passwort);
            Map(x => x.Status);
            Map(x => x.Created);
        }
    }
}
