﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using PersistenzManager;
using Fassade;
using RechteVerwaltungsKomponente;
using AnzeigenKomponente;
using System.IO;
using ProfilKomponente;

namespace WCF_Service
{
    [ServiceBehavior(Namespace = "http://marius-klausa.eu/board")]
    public class ServiceFassade : IFassadeSOAPInterface
    {

        private IÖffentlicheFassade fassade;

        public ServiceFassade()
        {
            this.fassade = Program.fassade;
        }

        public string Registrieren(string email, string passwort)
        {
            return fassade.Registrieren(email, passwort);
        }

        public string Login(string email, string passwort)
        {
            return fassade.Login(email, passwort);
        }

        public bool AccountAktivieren(string guid, string code)
        {
            return fassade.AccountAktivieren(guid, code);
        }

        public string GetAccountMail(string guid)
        {
            return fassade.GetAccountMail(guid);
        }

        public bool SendeAktivierungsmail(string guid)
        {
            return fassade.SendeAktivierungsmail(guid);
        }

        public bool IstAccountAktiviert(string guid)
        {
            return fassade.IstAccountAktiviert(guid);
        }

        public Profil GetProfil(string guid)
        {
            return fassade.GetProfil(guid);
        }

        public Profil GetProfilByRegisteredMail(string guid, string registeredEmail)
        {
            return fassade.GetProfilByRegisteredMail(guid, registeredEmail);
        }

        public IList<ProfilVorschau> GetAlleProfile(string guid)
        {
            return fassade.GetAlleProfile(guid);
        }

        public Profil ProfilAktualisieren(string guid, string nickname, string vorname, string nachname, bool nameVisible,
            string strasse, string plz, string stadt, bool adresseVisible, string telefon, bool telefonVisible,
            string email, bool emailVisible, int profilbildImageID, bool sichtbar)
        {
            return fassade.ProfilAktualisieren(guid, nickname, vorname, nachname, nameVisible, strasse, plz, stadt, adresseVisible, telefon, telefonVisible, email, emailVisible, profilbildImageID, sichtbar);
        }

        public TransportAnzeige AnzeigeErstellen(string guid, string titel, string beschreibung, string text, IList<Tag> tags, IDictionary<int, int> kategorie, string appearance, IList<int> images, KontaktOptionen kontaktOptionen = KontaktOptionen.Öffentliche)
        {
            return fassade.AnzeigeErstellen(guid, titel, beschreibung, text, tags, kategorie, appearance, images, kontaktOptionen);
        }

        public TransportAnzeige AnzeigeAktualisieren(string guid, int anzeigeID, string titel, string beschreibung, string text, IList<Tag> tags, IDictionary<int, int> kategorie, string appearance, IList<int> images)
        {
            return fassade.AnzeigeAktualisieren(guid, anzeigeID, titel, beschreibung, text, tags, kategorie, appearance, images);
        }

        public bool AnzeigeSetÖffentlichStatus(string guid, int anzeigeID, bool status)
        {
            return fassade.AnzeigeSetÖffentlichStatus(guid, anzeigeID, status);
        }

        public bool AnzeigeLöschen(string guid, int anzeigeID)
        {
            return fassade.AnzeigeLöschen(guid, anzeigeID);
        }

        public IList<Tag> GetAllTags()
        {
            return fassade.GetAllTags();
        }

        public IList<Kategorie> GetAllKategorien()
        {
            return fassade.GetAllKategorien();
        }

        public IList<TransportAnzeige> GetAllAnzeigen(string guid, int chunk)
        {
            return fassade.GetAllAnzeigen(guid, chunk);
        }

        public IList<TransportAnzeige> GetOwnAnzeigen(string guid, int chunk)
        {
            return fassade.GetOwnAnzeigen(guid, chunk);
        }

        public TransportAnzeige GetAnzeige(string guid, int anzeigeID)
        {
            return fassade.GetAnzeige(guid, anzeigeID);
        }

        public bool SendeAnzeigePerMail(string guid, int anzeigeID)
        {
            return fassade.SendeAnzeigePerMail(guid, anzeigeID);
        }

        public IList<TransportAnzeige> GetAllAnzeigenFromUser(string guid, string nickname, int chunk)
        {
            return fassade.GetAllAnzeigenFromUser(guid, nickname, chunk);
        }

        public FileTransferResult ImageErstellen(FileTransferRequest file)
        {
            return fassade.ImageErstellen(file);
        }

        public string GetImageHash(string guid, int imageID)
        {
            return fassade.GetImageHash(guid, imageID);
        }

        public string GetImagePath(string guid, int imageID)
        {
            return fassade.GetImagePath(guid, imageID);
        }

        public IList<string> GetImagePaths(string guid, IList<int> imageIDs)
        {
            return fassade.GetImagePaths(guid, imageIDs);
        }

        public bool IstOwnAnzeige(string guid, int anzeigeID)
        {
            return fassade.IstOwnAnzeige(guid, anzeigeID);
        }

        public bool PostFeedback(string guid, string text)
        {
            return fassade.PostFeedback(guid, text);
        }

        public IList<FeedbackKomponente.Feedback> GetFeedbackList(string guid, int chunk)
        {
            return fassade.GetFeedbackList(guid, chunk);
        }

        public Profil GetProfilByID(string guid, int profileAccountID)
        {
            return fassade.GetProfilByID(guid, profileAccountID);
        }

        public void IsAlive(string guid)
        {
            fassade.IsAlive(guid);
        }

        public bool Status()
        {
            return fassade.Status();
        }

        public void UploadLogfile(FileTransferRequest file)
        {
            fassade.UploadLogfile(file);
        }

        public bool ChangePassword(string guid, string guidToChange, string oldPW, string newPW)
        {
            return fassade.ChangePassword(guid, guidToChange, oldPW, newPW);
        }

        public bool DeleteKategorie(string guid, int kategorieID)
        {
            return fassade.DeleteKategorie(guid, kategorieID);
        }

        public Kategorie CreateKategorie(string guid, string name, IList<string> unterkategorien)
        {
            return fassade.CreateKategorie(guid, name, unterkategorien);
        }

        public string GetGuid(string guid, string email)
        {
            return fassade.GetGuid(guid, email);
        }

        public string CreateAccount(string guid, string email, string passwort, bool activated)
        {
            return fassade.CreateAccount(guid, email, passwort, activated);
        }

        public void SendRundmail(string guid, string subject, string text)
        {
            fassade.SendRundmail(guid, subject, text);
        }
    }
}
